diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/impl/EnumSettingNode.java b/game/core/src/main/java/net/minecraft/core/world/settings/impl/EnumSettingNode.java
new file mode 100644
index 000000000..eda4c59e2
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/impl/EnumSettingNode.java
@@ -0,0 +1,61 @@
+package net.minecraft.core.world.settings.impl;
+
+import com.mojang.nbt.tags.StringTag;
+import com.mojang.nbt.tags.Tag;
+import net.minecraft.core.lang.text.IntoText;
+import net.minecraft.core.lang.text.Text;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.save.WorldConfigurationReader;
+import net.minecraft.core.world.settings.ListValueSettingNode;
+import net.minecraft.core.world.settings.ValueGenericSettingNode;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.Arrays;
+import java.util.List;
+import java.util.Objects;
+import java.util.zip.DataFormatException;
+
+public class EnumSettingNode<T extends Enum<T> & IntoText> extends ValueGenericSettingNode<T> implements ListValueSettingNode<T> {
+    final @NotNull T defaultValue;
+
+    public EnumSettingNode(final @NotNull String key, final @NotNull Text name, final @NotNull T defaultValue) {
+        super(key, name, defaultValue.getDeclaringClass());
+
+        this.defaultValue = defaultValue;
+    }
+
+    @Override
+    public @NotNull T getDefaultValue(final @NotNull Dimension dimension, final @NotNull WorldConfigurationReader config) {
+        return this.defaultValue;
+    }
+
+    @Override
+    public @NotNull Text getValueText(final @NotNull T value) {
+        return value.intoText();
+    }
+
+    @Override
+    public @NotNull Tag<?> serializeValue(final @NotNull T value) {
+        return new StringTag(value.name());
+    }
+
+    @Override
+    public @NotNull T deserializeValue(final @NotNull Tag<?> tag) throws DataFormatException {
+        if (tag instanceof final @NotNull StringTag stringTag) {
+            final @NotNull String string = stringTag.getValue();
+
+            try {
+                return T.valueOf(this.getValueClass(), string);
+            } catch (final @NotNull IllegalArgumentException e) {
+                throw new DataFormatException("Illegal enum value in tag!");
+            }
+        } else {
+            throw new DataFormatException("Tag was wrong type!");
+        }
+    }
+
+    @Override
+    public @NotNull List<T> getValues(final @NotNull Dimension dimension, final @NotNull WorldConfigurationReader config) {
+        return Arrays.asList(Objects.requireNonNull(this.getValueClass().getEnumConstants()));
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/impl/PercentageSettingNode.java b/game/core/src/main/java/net/minecraft/core/world/settings/impl/PercentageSettingNode.java
new file mode 100644
index 000000000..b6d188b6e
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/impl/PercentageSettingNode.java
@@ -0,0 +1,71 @@
+package net.minecraft.core.world.settings.impl;
+
+import com.mojang.nbt.tags.FloatTag;
+import com.mojang.nbt.tags.Tag;
+import net.minecraft.core.lang.text.LiteralText;
+import net.minecraft.core.lang.text.Text;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.save.WorldConfigurationReader;
+import net.minecraft.core.world.settings.RangeValueSettingNode;
+import net.minecraft.core.world.settings.ValueGenericSettingNode;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.zip.DataFormatException;
+
+public class PercentageSettingNode extends ValueGenericSettingNode<@NotNull Float> implements RangeValueSettingNode<@NotNull Float> {
+    private final float defaultValue;
+
+    public PercentageSettingNode(final @NotNull String key, final @NotNull Text name, final float defaultValue) {
+        super(key, name, Float.class);
+
+        this.defaultValue = defaultValue;
+    }
+
+    @Override
+    public @NotNull Float getMinimumValue(final @NotNull Dimension dimension, final @NotNull WorldConfigurationReader config) {
+        return 0.0f;
+    }
+
+    @Override
+    public @NotNull Float getMaximumValue(final @NotNull Dimension dimension, final @NotNull WorldConfigurationReader config) {
+        return 1.0f;
+    }
+
+    @Override
+    public @NotNull Float getDefaultValue(final @NotNull Dimension dimension, final @NotNull WorldConfigurationReader config) {
+        return this.defaultValue;
+    }
+
+    @Override
+    public boolean validateValue(final @NotNull Float value, final @NotNull Dimension dimension, final @NotNull WorldConfigurationReader config) {
+        return value >= this.getMinimumValue(dimension, config) && value <= this.getMaximumValue(dimension, config);
+    }
+
+    @Override
+    public @NotNull Text getValueText(final @Nullable Float value) {
+        if (value == null) {
+            throw new IllegalArgumentException("Value cannot be null!");
+        }
+
+        return new LiteralText((int)(value * 100.0) + "%");
+    }
+
+    @Override
+    public @NotNull Tag<?> serializeValue(final @Nullable Float value) {
+        if (value == null) {
+            throw new IllegalArgumentException("Value cannot be null!");
+        }
+
+        return new FloatTag(value);
+    }
+
+    @Override
+    public @NotNull Float deserializeValue(final @NotNull Tag<?> tag) throws DataFormatException {
+        if (tag instanceof final @NotNull FloatTag floatTag) {
+            return floatTag.getValue();
+        } else {
+            throw new DataFormatException("Tag was wrong type!");
+        }
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/impl/RangeIntegerSettingNode.java b/game/core/src/main/java/net/minecraft/core/world/settings/impl/RangeIntegerSettingNode.java
new file mode 100644
index 000000000..dc1d04f28
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/impl/RangeIntegerSettingNode.java
@@ -0,0 +1,67 @@
+package net.minecraft.core.world.settings.impl;
+
+import com.mojang.nbt.tags.FloatTag;
+import com.mojang.nbt.tags.IntTag;
+import com.mojang.nbt.tags.Tag;
+import net.minecraft.core.lang.text.LiteralText;
+import net.minecraft.core.lang.text.Text;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.save.WorldConfigurationReader;
+import net.minecraft.core.world.settings.RangeValueSettingNode;
+import net.minecraft.core.world.settings.ValueGenericSettingNode;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.zip.DataFormatException;
+
+public class RangeIntegerSettingNode extends ValueGenericSettingNode<@NotNull Integer> implements RangeValueSettingNode<@NotNull Integer> {
+    private final int minValue;
+    private final int maxValue;
+    private final int defaultValue;
+
+    public RangeIntegerSettingNode(final @NotNull String key, final @NotNull Text name, final int minValue, final int maxValue, final int defaultValue) {
+        super(key, name, Integer.class);
+
+        this.minValue = minValue;
+        this.maxValue = maxValue;
+        this.defaultValue = defaultValue;
+    }
+
+    @Override
+    public @NotNull Integer getMinimumValue(final @NotNull Dimension dimension, final @NotNull WorldConfigurationReader config) {
+        return this.minValue;
+    }
+
+    @Override
+    public @NotNull Integer getMaximumValue(final @NotNull Dimension dimension, final @NotNull WorldConfigurationReader config) {
+        return this.maxValue;
+    }
+
+    @Override
+    public @NotNull Integer getDefaultValue(final @NotNull Dimension dimension, final @NotNull WorldConfigurationReader config) {
+        return this.defaultValue;
+    }
+
+    @Override
+    public boolean validateValue(final @NotNull Integer value, final @NotNull Dimension dimension, final @NotNull WorldConfigurationReader config) {
+        return value >= this.getMinimumValue(dimension, config) && value <= this.getMaximumValue(dimension, config);
+    }
+
+    @Override
+    public @NotNull Text getValueText(final @NotNull Integer value) {
+        return new LiteralText("" + value);
+    }
+
+    @Override
+    public @NotNull Tag<?> serializeValue(final @NotNull Integer value) {
+        return new IntTag(value);
+    }
+
+    @Override
+    public @NotNull Integer deserializeValue(final @NotNull Tag<?> tag) throws DataFormatException {
+        if (tag instanceof final @NotNull IntTag intTag) {
+            return intTag.getValue();
+        } else {
+            throw new DataFormatException("Tag was wrong type!");
+        }
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/impl/SeasonSettingNode.java b/game/core/src/main/java/net/minecraft/core/world/settings/impl/SeasonSettingNode.java
index a0457deb2..b51b59ed2 100644
--- a/game/core/src/main/java/net/minecraft/core/world/settings/impl/SeasonSettingNode.java
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/impl/SeasonSettingNode.java
@@ -1,38 +1,75 @@
 package net.minecraft.core.world.settings.impl;
 
-import net.minecraft.core.lang.text.IntoText;
+import com.mojang.nbt.tags.StringTag;
+import com.mojang.nbt.tags.Tag;
 import net.minecraft.core.lang.text.Text;
 import net.minecraft.core.lang.text.TranslatableText;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.config.season.SeasonConfig;
+import net.minecraft.core.world.config.season.SeasonConfigCycle;
+import net.minecraft.core.world.config.season.SeasonConfigSingle;
+import net.minecraft.core.world.save.WorldConfigurationReader;
 import net.minecraft.core.world.season.Season;
-import net.minecraft.core.world.settings.ListValueGenericSettingNode;
+import net.minecraft.core.world.season.Seasons;
+import net.minecraft.core.world.settings.ListValueSettingNode;
+import net.minecraft.core.world.settings.ValueGenericSettingNode;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class SeasonSettingNode extends ListValueGenericSettingNode<SeasonSettingNode.SeasonEntry> {
-    public static class SeasonEntry implements IntoText {
-        private final @NotNull Text text;
+import java.util.List;
+import java.util.zip.DataFormatException;
 
-        public final @Nullable Season season;
+public class SeasonSettingNode extends ValueGenericSettingNode<@NotNull Season> implements ListValueSettingNode<@NotNull Season> {
+    public SeasonSettingNode(final @NotNull String key, final @NotNull Text name) {
+        super(key, name, Season.class);
+    }
 
-        private SeasonEntry() {
-            this.season = null;
-            this.text = new TranslatableText("world_settings.single_season.disabled");
+    @Override
+    public @NotNull List<@NotNull Season> getValues(final @NotNull Dimension dimension, final @NotNull WorldConfigurationReader config) {
+        final @NotNull SeasonConfig seasonConfig = config.getWorldType(dimension).getSeasonConfig();
+        if (seasonConfig instanceof final @NotNull SeasonConfigCycle cycle) {
+            return cycle.getSeasons();
+        } else if (seasonConfig instanceof final @NotNull SeasonConfigSingle single) {
+            return List.of(single.getSingleSeason());
+        } else {
+            throw new IllegalStateException("Illegal SeasonConfig!");
         }
+    }
 
-        public SeasonEntry(final @NotNull Season season) {
-            this.season = season;
-            this.text = new TranslatableText(season.getLanguageKey());
-        }
+    @Override
+    public @NotNull Season getDefaultValue(final @NotNull Dimension dimension, final @NotNull WorldConfigurationReader config) {
+        return this.getValues(dimension, config).get(0);
+    }
 
-        @Override
-        public @NotNull Text intoText() {
-            return this.text;
+    @Override
+    public @NotNull Text getValueText(final @Nullable Season value) {
+        if (value == null) {
+            return new TranslatableText("world_settings.single_season.values.disabled");
+        } else {
+            return new TranslatableText(value.getLanguageKey() + ".name");
         }
     }
 
-    public static final @NotNull SeasonEntry DISABLED = new SeasonEntry();
+    @Override
+    public @NotNull Tag<?> serializeValue(final @Nullable Season value) {
+        if (value == null) {
+            return new StringTag("");
+        } else {
+            return new StringTag(value.getId());
+        }
+    }
 
-    public SeasonSettingNode(final @NotNull String key, final @NotNull Text name, final @NotNull SeasonEntry defaultValue) {
-        super(key, name, defaultValue);
+    @Override
+    public @NotNull Season deserializeValue(final @NotNull Tag<?> tag) throws DataFormatException {
+        if (tag instanceof final @NotNull StringTag stringTag) {
+            final @Nullable Season season = Seasons.getSeason(stringTag.getValue());
+            if (season != null) {
+                return season;
+            } else {
+                throw new DataFormatException("Illegal season ID in tag!");
+            }
+        } else {
+            throw new DataFormatException("Tag was wrong type!");
+        }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/impl/WorldHeightSettingNode.java b/game/core/src/main/java/net/minecraft/core/world/settings/impl/WorldHeightSettingNode.java
new file mode 100644
index 000000000..2000a92c9
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/impl/WorldHeightSettingNode.java
@@ -0,0 +1,72 @@
+package net.minecraft.core.world.settings.impl;
+
+import net.minecraft.core.lang.text.LiteralText;
+import net.minecraft.core.lang.text.Text;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.save.WorldConfigurationReader;
+import net.minecraft.core.world.settings.WorldSettingNodes;
+import org.jetbrains.annotations.NotNull;
+
+public class WorldHeightSettingNode extends RangeIntegerSettingNode {
+    public static final int VALUE_SCALE = 16;
+    public static final int DEFAULT_MIN = 0;
+    public static final int DEFAULT_MAX = 16;
+
+    public enum ValueType {
+        BOTTOM,
+        TOP;
+    }
+
+    private final @NotNull ValueType valueType;
+
+    public WorldHeightSettingNode(final @NotNull String key, final @NotNull Text name, final int defaultValue, final @NotNull ValueType valueType) {
+        super(key, name, 0, 16, defaultValue);
+
+        this.valueType = valueType;
+    }
+
+    @Override
+    public @NotNull Integer getMinimumValue(final @NotNull Dimension dimension, final @NotNull WorldConfigurationReader config) {
+        final int bottomValue = config.getDimensionSettings(dimension).getNodeValueOr(WorldSettingNodes.WORLD_HEIGHT_BOTTOM, DEFAULT_MIN);
+
+        final int baseMin = super.getMinimumValue(dimension, config);
+
+        return switch (this.valueType) {
+            case BOTTOM -> baseMin;
+            case TOP -> bottomValue + 1;
+        };
+    }
+
+    @Override
+    public @NotNull Integer getMaximumValue(final @NotNull Dimension dimension, final @NotNull WorldConfigurationReader config) {
+        final int topValue = config.getDimensionSettings(dimension).getNodeValueOr(WorldSettingNodes.WORLD_HEIGHT_TOP, DEFAULT_MAX);
+
+        final int baseMax = super.getMaximumValue(dimension, config);
+
+        return switch (this.valueType) {
+            case BOTTOM -> topValue - 1;
+            case TOP -> baseMax;
+        };
+    }
+
+    @Override
+    public @NotNull Integer getDefaultValue(final @NotNull Dimension dimension, final @NotNull WorldConfigurationReader config) {
+        final int baseDefault = super.getDefaultValue(dimension, config);
+        final int baseMin = super.getMinimumValue(dimension, config);
+        final int baseMax = super.getMaximumValue(dimension, config);
+
+        final int bottomValue = config.getDimensionSettings(dimension).getNodeValueOr(WorldSettingNodes.WORLD_HEIGHT_BOTTOM, DEFAULT_MIN);
+        final int topValue = config.getDimensionSettings(dimension).getNodeValueOr(WorldSettingNodes.WORLD_HEIGHT_TOP, DEFAULT_MAX);
+
+        return switch (this.valueType) {
+            case BOTTOM -> MathHelper.clamp(baseDefault, baseMin, topValue - 1);
+            case TOP -> MathHelper.clamp(baseDefault, bottomValue + 1, baseMax);
+        };
+    }
+
+    @Override
+    public @NotNull Text getValueText(final @NotNull Integer value) {
+        return new LiteralText("" + (VALUE_SCALE * value));
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java b/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
index d45ea3c07..aa5cf8f09 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
@@ -11,6 +11,8 @@ import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.save.LevelData;
 import net.minecraft.core.world.season.Seasons;
+import net.minecraft.core.world.settings.WorldSettingNodes;
+import net.minecraft.core.world.settings.impl.WorldHeightSettingNode;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.Weathers;
 import net.minecraft.core.world.wind.WindProvider;
@@ -89,16 +91,16 @@ public abstract class WorldType {
         return seasonConfig;
     }
 
-    public int getMinY() {
-        return minY;
+    public int getMinY(final @NotNull World world) {
+        return world.getWorldSetting(WorldSettingNodes.WORLD_HEIGHT_BOTTOM) * WorldHeightSettingNode.VALUE_SCALE;
     }
 
     public int getMinPortalY() {
         return minPortalY;
     }
 
-    public int getMaxY() {
-        return maxY;
+    public int getMaxY(final @NotNull World world) {
+        return (world.getWorldSetting(WorldSettingNodes.WORLD_HEIGHT_TOP) * WorldHeightSettingNode.VALUE_SCALE) - 1;
     }
 
     public int getMaxPortalY() {
@@ -131,13 +133,13 @@ public abstract class WorldType {
 
     public void onWorldCreation(World world) { }
 
-    public final int getYRange() {
-        return getMaxY() - getMinY();
+    public final int getYRange(final @NotNull World world) {
+        return getMaxY(world) - getMinY(world);
     }
 
-    public final double getYPercentage(int y) {
-        int range = getYRange();
-        y -= getMinY();
+    public final double getYPercentage(final @NotNull World world, int y) {
+        int range = getYRange(world);
+        y -= getMinY(world);
         return (double)y / (double)range;
     }
 
@@ -150,6 +152,9 @@ public abstract class WorldType {
     public abstract boolean isValidSpawn(World world, int x, int y, int z);
 
     public void getInitialSpawnLocation(World world, @Nullable Biome startingBiome) {
+        final int minY = this.getMinY(world);
+        final int maxY = this.getMaxY(world);
+
         TilePos queryPos = new TilePos();
         TilePos spawnPos = new TilePos();
         if (startingBiome != null) {
@@ -195,7 +200,7 @@ public abstract class WorldType {
             }
             spawnPos.x += random.nextInt(64) - random.nextInt(64);
             spawnPos.z += random.nextInt(64) - random.nextInt(64);
-            for (spawnPos.y = getMaxY(); spawnPos.y >= getMinY(); spawnPos.y--) {
+            for (spawnPos.y = maxY; spawnPos.y >= minY; spawnPos.y--) {
                 Block<?> b = world.getBlockType(spawnPos.up(queryPos));
                 if (b.getCollisionAABB(world, queryPos) == null && !b.getMaterial().isLiquid() && isValidSpawn(world, spawnPos.x, spawnPos.y, spawnPos.z)) {
                     break spawnLoop;
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeDebug.java b/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeDebug.java
index d2abd3115..1067b3471 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeDebug.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeDebug.java
@@ -26,7 +26,7 @@ public class WorldTypeDebug
 
     @Override
     public @NotNull BiomeProvider createBiomeProvider(World world) {
-        return new BiomeProviderSingleBiome(Biomes.OVERWORLD_PLAINS, 1.0, 1.0, 1.0);
+        return new BiomeProviderSingleBiome(world, Biomes.OVERWORLD_PLAINS, 1.0, 1.0, 1.0);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeEmpty.java b/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeEmpty.java
index 514d28a5b..8e1eab9db 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeEmpty.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeEmpty.java
@@ -31,7 +31,7 @@ public class WorldTypeEmpty
 
     @Override
     public @NotNull BiomeProvider createBiomeProvider(World world) {
-        return new BiomeProviderSingleBiome(Biomes.OVERWORLD_PLAINS, 1.0, 1.0, 1.0);
+        return new BiomeProviderSingleBiome(world, Biomes.OVERWORLD_PLAINS, 1.0, 1.0, 1.0);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/drift/WorldTypeDrift.java b/game/core/src/main/java/net/minecraft/core/world/type/drift/WorldTypeDrift.java
index 72ff79c14..f9f47b6f6 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/drift/WorldTypeDrift.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/drift/WorldTypeDrift.java
@@ -54,7 +54,7 @@ public class WorldTypeDrift
 
     @Override
     public @NotNull BiomeProvider createBiomeProvider(World world) {
-        return new BiomeProviderSingleBiome(Biomes.DRIFT_DRIFT, 0.5, 0.0, 0.0);
+        return new BiomeProviderSingleBiome(world, Biomes.DRIFT_DRIFT, 0.5, 0.0, 0.0);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java b/game/core/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java
index 2090ca074..3ef04360f 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java
@@ -44,7 +44,7 @@ public class WorldTypeNether
 
     @Override
     public @NotNull BiomeProvider createBiomeProvider(World world) {
-        return new BiomeProviderNether(world.getRandomSeed());
+        return new BiomeProviderNether(world);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeFlat.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeFlat.java
index 7fe2b1d83..dc417f8c7 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeFlat.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeFlat.java
@@ -18,7 +18,7 @@ public class WorldTypeFlat
 
     @Override
     public @NotNull BiomeProvider createBiomeProvider(World world) {
-        return new BiomeProviderSingleBiome(Biomes.OVERWORLD_PLAINS, 0.5, 0.0, 0.0);
+        return new BiomeProviderSingleBiome(world, Biomes.OVERWORLD_PLAINS, 0.5, 0.0, 0.0);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java
index d05a103d0..f1d3328e7 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java
@@ -14,8 +14,7 @@ import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.weather.Weather;
 import org.jetbrains.annotations.NotNull;
 
-public class WorldTypeOverworld
-        extends WorldType {
+public class WorldTypeOverworld extends WorldType {
     public WorldTypeOverworld(Properties properties) {
         super(properties);
     }
@@ -55,7 +54,7 @@ public class WorldTypeOverworld
 
     @Override
     public @NotNull BiomeProvider createBiomeProvider(World world) {
-        return new BiomeProviderOverworld(world.getRandomSeed(), this);
+        return new BiomeProviderOverworld(world);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldB173.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldB173.java
index c15c2ebeb..e5e15bb5a 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldB173.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldB173.java
@@ -16,7 +16,7 @@ public class WorldTypeOverworldB173
 
     @Override
     public @NotNull BiomeProvider createBiomeProvider(World world) {
-        return new BiomeProviderB173(world.getRandomSeed());
+        return new BiomeProviderB173(world);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldClassic.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldClassic.java
index 1c75f2e40..6e530f165 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldClassic.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldClassic.java
@@ -18,7 +18,7 @@ public class WorldTypeOverworldClassic
 
     @Override
     public @NotNull BiomeProvider createBiomeProvider(World world) {
-        return new BiomeProviderSingleBiome(Biomes.OVERWORLD_RETRO, 1.0, 1.0, 1.0);
+        return new BiomeProviderSingleBiome(world, Biomes.OVERWORLD_RETRO, 1.0, 1.0, 1.0);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldFloating.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldFloating.java
index 2acf4fb1f..bade08577 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldFloating.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldFloating.java
@@ -17,7 +17,7 @@ public class WorldTypeOverworldFloating
 
     @Override
     public @NotNull BiomeProvider createBiomeProvider(World world) {
-        return new BiomeProviderOverworld(world.getRandomSeed(), this)
+        return new BiomeProviderOverworld(world)
                 .withTemperatureScales(0.00625, 0.00625, 0.25, 0.01)
                 .withHumidityScales(0.0125, 0.0125, 0.3, 0.01)
                 .withNoiseScales(8, 8, 0.025);
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldHell.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldHell.java
index 20f8898e5..7dd0349df 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldHell.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldHell.java
@@ -24,7 +24,7 @@ public class WorldTypeOverworldHell
 
     @Override
     public @NotNull BiomeProvider createBiomeProvider(World world) {
-        return new BiomeProviderSingleBiome(Biomes.OVERWORLD_HELL, 1.0, 1.0, 0.0);
+        return new BiomeProviderSingleBiome(world, Biomes.OVERWORLD_HELL, 1.0, 1.0, 0.0);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldIndev.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldIndev.java
index 8337b9fc9..5f02e681c 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldIndev.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldIndev.java
@@ -29,6 +29,9 @@ public class WorldTypeOverworldIndev
 
     @Override
     public void getInitialSpawnLocation(World world, @Nullable Biome startingBiome) {
+        final int minY = world.getWorldType().getMinY(world);
+        final int maxY = world.getWorldType().getMaxY(world);
+
         int x;
         int y;
         int z;
@@ -37,7 +40,7 @@ public class WorldTypeOverworldIndev
         while (true) {
             x = random.nextInt(256);
             z = random.nextInt(256);
-            for (y = getMaxY(); y >= getMinY(); y--) {
+            for (y = maxY; y >= minY; y--) {
                 if (world.getBlockId(x, y + 1, z) == 0 && isValidSpawn(world, x, y, z)) {
                     break spawnLoop;
                 }
@@ -54,7 +57,7 @@ public class WorldTypeOverworldIndev
 
     @Override
     public @NotNull BiomeProvider createBiomeProvider(World world) {
-        return new BiomeProviderSingleBiome(Biomes.OVERWORLD_RETRO, 1.0, 1.0, 1.0);
+        return new BiomeProviderSingleBiome(world, Biomes.OVERWORLD_RETRO, 1.0, 1.0, 1.0);
     }
 
     @Override
@@ -64,6 +67,6 @@ public class WorldTypeOverworldIndev
 
     @Override
     public ChunkGenerator createChunkGenerator(World world) {
-        return new ChunkGeneratorIndev(world, 256, getMaxY() + 1, 256, IndevWorldType.ISLAND, IndevWorldTheme.NORMAL);
+        return new ChunkGeneratorIndev(world, 256, getMaxY(world) + 1, 256, IndevWorldType.ISLAND, IndevWorldTheme.NORMAL);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldRetro.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldRetro.java
index af2d80f60..ffe66fb0f 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldRetro.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldRetro.java
@@ -17,7 +17,7 @@ public class WorldTypeOverworldRetro
 
     @Override
     public @NotNull BiomeProvider createBiomeProvider(World world) {
-        return new BiomeProviderSingleBiome(Biomes.OVERWORLD_RETRO, 1.0, 1.0, 1.0);
+        return new BiomeProviderSingleBiome(world, Biomes.OVERWORLD_RETRO, 1.0, 1.0, 1.0);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldSkyblock.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldSkyblock.java
index 509afb222..0b99fc98c 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldSkyblock.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldSkyblock.java
@@ -18,7 +18,7 @@ public class WorldTypeOverworldSkyblock
 
     @Override
     public @NotNull BiomeProvider createBiomeProvider(World world) {
-        return new BiomeProviderSingleBiome(Biomes.OVERWORLD_PLAINS, 1.0, 1.0, 1.0);
+        return new BiomeProviderSingleBiome(world, Biomes.OVERWORLD_PLAINS, 1.0, 1.0, 1.0);
     }
 
     @Override
diff --git a/game/core/src/main/resources/lang/en_US/gui.lang b/game/core/src/main/resources/lang/en_US/gui.lang
index 3edc9f344..481a324ef 100644
--- a/game/core/src/main/resources/lang/en_US/gui.lang
+++ b/game/core/src/main/resources/lang/en_US/gui.lang
@@ -100,6 +100,8 @@ gui.world_settings.label.title=World Settings
 gui.world_settings.button.done=Done
 gui.world_settings.page.game_rules.title=Game Rules
 gui.world_settings.page.world_settings.title=World Settings
+gui.world_settings.page.world_settings.category.overworld=Overworld
+gui.world_settings.page.world_settings.category.nether=Nether
 gui.world_settings.page.game_rules.button.on=ON
 gui.world_settings.page.game_rules.button.off=OFF
 gui.world_settings.page.mob_spawning.title=Mob Spawning
